
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Accountant_client_accessesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const accountant_client_accesses = await db.accountant_client_accesses.create(
            {
                id: data.id || undefined,
        
        status: data.status
        ||
        null
            ,
            
        access_granted: data.access_granted
        ||
        false
        
            ,
            
        granted_at: data.granted_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await accountant_client_accesses.setAccountant( data.accountant || null, {
            transaction,
        });
        
        await accountant_client_accesses.setClient( data.client || null, {
            transaction,
        });
        
        await accountant_client_accesses.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return accountant_client_accesses;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const accountant_client_accessesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                status: item.status
            ||
            null
            ,
            
                access_granted: item.access_granted
            ||
            false
        
            ,
            
                granted_at: item.granted_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const accountant_client_accesses = await db.accountant_client_accesses.bulkCreate(accountant_client_accessesData, { transaction });

        // For each item created, replace relation files
        

        return accountant_client_accesses;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const accountant_client_accesses = await db.accountant_client_accesses.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.access_granted !== undefined) updatePayload.access_granted = data.access_granted;
        
        
        if (data.granted_at !== undefined) updatePayload.granted_at = data.granted_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await accountant_client_accesses.update(updatePayload, {transaction});

        
        
        if (data.accountant !== undefined) {
            await accountant_client_accesses.setAccountant(
              
              data.accountant,
              
              { transaction }
            );
        }
        
        if (data.client !== undefined) {
            await accountant_client_accesses.setClient(
              
              data.client,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await accountant_client_accesses.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return accountant_client_accesses;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const accountant_client_accesses = await db.accountant_client_accesses.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of accountant_client_accesses) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of accountant_client_accesses) {
                await record.destroy({transaction});
            }
        });


        return accountant_client_accesses;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const accountant_client_accesses = await db.accountant_client_accesses.findByPk(id, options);

        await accountant_client_accesses.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await accountant_client_accesses.destroy({
            transaction
        });

        return accountant_client_accesses;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const accountant_client_accesses = await db.accountant_client_accesses.findOne(
            { where },
            { transaction },
        );

        if (!accountant_client_accesses) {
            return accountant_client_accesses;
        }

        const output = accountant_client_accesses.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.accountant = await accountant_client_accesses.getAccountant({
            transaction
        });
        
        
        output.client = await accountant_client_accesses.getClient({
            transaction
        });
        
        
        output.organizations = await accountant_client_accesses.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'accountant',
        
        where: filter.accountant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.accountant.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.accountant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'client',
        
        where: filter.client ? {
          [Op.or]: [
            { id: { [Op.in]: filter.client.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.client.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.granted_atRange) {
                const [start, end] = filter.granted_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    granted_at: {
                    ...where.granted_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    granted_at: {
                    ...where.granted_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.access_granted) {
                where = {
                    ...where,
                access_granted: filter.access_granted,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.accountant_client_accesses.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'accountant_client_accesses',
                        'status',
                        query,
                    ),
                ],
            };
        }

        const records = await db.accountant_client_accesses.findAll({
            attributes: [ 'id', 'status' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['status', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.status,
        }));
    }

    
};

